VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmAlpha 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Alpha Blend Demo"
   ClientHeight    =   3630
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4965
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3630
   ScaleWidth      =   4965
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdDraw2 
      Caption         =   "Draw Faster"
      Height          =   375
      Left            =   1800
      TabIndex        =   1
      Top             =   3120
      Width           =   1335
   End
   Begin VB.CommandButton cmdDraw 
      Caption         =   "Draw"
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Top             =   3120
      Width           =   1335
   End
   Begin MSComctlLib.Slider Slider1 
      Height          =   375
      Left            =   240
      TabIndex        =   3
      Top             =   2520
      Width           =   4455
      _ExtentX        =   7858
      _ExtentY        =   661
      _Version        =   393216
      LargeChange     =   10
      SmallChange     =   5
      Max             =   100
      SelStart        =   50
      TickFrequency   =   10
      Value           =   50
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   3360
      TabIndex        =   2
      Top             =   3120
      Width           =   1335
   End
   Begin VB.PictureBox picResult 
      Height          =   1560
      Left            =   3360
      ScaleHeight     =   100
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   87
      TabIndex        =   6
      TabStop         =   0   'False
      Top             =   480
      Width           =   1365
   End
   Begin VB.PictureBox picSrc2 
      AutoRedraw      =   -1  'True
      Height          =   1560
      Left            =   1800
      Picture         =   "frmAlpha.frx":0000
      ScaleHeight     =   100
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   87
      TabIndex        =   5
      TabStop         =   0   'False
      Top             =   480
      Width           =   1365
   End
   Begin VB.PictureBox picSrc1 
      AutoRedraw      =   -1  'True
      Height          =   1560
      Left            =   240
      Picture         =   "frmAlpha.frx":6764
      ScaleHeight     =   100
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   87
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   480
      Width           =   1365
   End
   Begin VB.Label Label4 
      Alignment       =   2  'Center
      Caption         =   "Source1 Opacity %"
      Height          =   255
      Left            =   480
      TabIndex        =   10
      Top             =   2280
      Width           =   3975
   End
   Begin VB.Label Label3 
      Caption         =   "Result"
      Height          =   255
      Left            =   3360
      TabIndex        =   9
      Top             =   240
      Width           =   1335
   End
   Begin VB.Label Label2 
      Caption         =   "Source2"
      Height          =   255
      Left            =   1800
      TabIndex        =   8
      Top             =   240
      Width           =   1335
   End
   Begin VB.Label Label1 
      Caption         =   "Source1"
      Height          =   255
      Left            =   240
      TabIndex        =   7
      Top             =   240
      Width           =   1335
   End
End
Attribute VB_Name = "frmAlpha"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'// AlphaBlend demo (24 bit color)
'// by Paul Pagel
'// DigiTorus@xoommail.com

'// The VB Code Node
'// http://members.xoom.com/DigiTorus/


Private Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type

Private Type RGBTHREE  'integer form of RGBTRIPLE
    rgbtBlue As Integer
    rgbtGreen As Integer
    rgbtRed As Integer
End Type

Private Declare Function GetBitmapBits Lib "gdi32" (ByVal hBitmap As Long, ByVal dwCount As Long, lpBits As Any) As Long
Private Declare Function SetBitmapBits Lib "gdi32" (ByVal hBitmap As Long, ByVal dwCount As Long, lpBits As Any) As Long
Private Declare Function GetObjectAPI Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function SetPixelV Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long


Private Sub cmdCancel_Click()
    
    Unload Me
End Sub

Private Sub cmdDraw_Click()
    
    '// pixel-by-pixel method for doing alpha blending
    
    Dim nX As Long
    Dim nY As Long
    
    Dim nSrc1Color As Long
    Dim nSrc2Color As Long
    Dim nResultColor As Long
    
    For nY = 0 To picSrc1.ScaleHeight - 1
        For nX = 0 To picSrc1.ScaleWidth - 1
            'get the two source picture pixel colors
            nSrc1Color = GetPixel(picSrc1.hdc, nX, nY)
            nSrc2Color = GetPixel(picSrc2.hdc, nX, nY)
            nResultColor = AlphaBlendRGB(nSrc1Color, nSrc2Color, Slider1.Value)
            SetPixelV picResult.hdc, nX, nY, nResultColor
        Next nX
    Next nY
    
End Sub

Private Sub cmdDraw2_Click()
    
    '// faster method for doing alpha blending using
    '// byte arrays for bitmap manipulation
    
    Dim nX As Long, nY As Long
    
    Dim bm1 As BITMAP
    Dim bm2 As BITMAP
    Dim bmRes As BITMAP
    
    Dim byteSrc1() As Byte
    Dim byteSrc2() As Byte
    Dim byteRes() As Byte
    
    Dim nWd1 As Long, nHt1 As Long
    Dim nWd2 As Long, nHt2 As Long
    Dim nWdRes As Long, nHtRes As Long
    
    Dim iOpacity1 As Integer
    Dim iOpacity2 As Integer
    
    '// get Source1 bitmap
    GetObjectAPI picSrc1.Image, Len(bm1), bm1
    nWd1 = bm1.bmWidthBytes
    nHt1 = bm1.bmHeight
    ReDim byteSrc1(0 To nWd1 - 1, 0 To nHt1 - 1)
    GetBitmapBits picSrc1.Image, nWd1 * nHt1, byteSrc1(0, 0)
    
    '// get Source2 bitmap
    GetObjectAPI picSrc2.Image, Len(bm2), bm2
    nWd2 = bm2.bmWidthBytes
    nHt2 = bm2.bmHeight
    ReDim byteSrc2(0 To nWd2 - 1, 0 To nHt2 - 1)
    GetBitmapBits picSrc2.Image, nWd2 * nHt2, byteSrc2(0, 0)
    
    '// prepare array for result bitmap
    GetObjectAPI picResult.Image, Len(bmRes), bmRes
    nWdRes = bmRes.bmWidthBytes
    nHtRes = bmRes.bmHeight
    ReDim byteRes(0 To nWdRes - 1, 0 To nHtRes - 1)
    
    iOpacity1 = Slider1.Value
    iOpacity2 = 100 - iOpacity1
    
    '// get weighted average for each byte in the source bitmaps
    '// and place it in the result bitmap array
    For nY = 0 To bm1.bmHeight - 1
        For nX = 0 To bm1.bmWidthBytes - 1
            byteRes(nX, nY) = (CInt(byteSrc1(nX, nY)) * iOpacity1 + CInt(byteSrc2(nX, nY)) * iOpacity2) \ 100
        Next nX
    Next nY
    
    '// copy the new bitmap data to the result image
    SetBitmapBits picResult.Image, bmRes.bmWidthBytes * bmRes.bmHeight, byteRes(0, 0)
    picResult.Refresh
End Sub



Private Function AlphaBlendRGB(ByVal Color1 As Long, ByVal Color2 As Long, ByVal Opacity1 As Integer) As Long
    
    '// blends the RGB values according to the passed
    '// opacity and returns the resulting long color value
    
    Dim src1 As RGBTHREE
    Dim src2 As RGBTHREE
    Dim nRed As Long
    Dim nGreen As Long
    Dim nBlue As Long
    
    '// separate the source colors into their RGB components
    GetRGB Color1, src1
    GetRGB Color2, src2
    
    '// find the weighted average of each color component
    nRed = (src1.rgbtRed * Opacity1 + src2.rgbtRed * (100 - Opacity1)) \ 100
    nGreen = (src1.rgbtGreen * Opacity1 + src2.rgbtGreen * (100 - Opacity1)) \ 100
    nBlue = (src1.rgbtBlue * Opacity1 + src2.rgbtBlue * (100 - Opacity1)) \ 100
    
    '// either one of these will work to calculate the
    '// long color value from the component values
    'AlphaBlendRGB = nRed + (nGreen * 256) + (nBlue * 65536)
    AlphaBlendRGB = RGB(nRed, nGreen, nBlue)
End Function

Private Function GetRGB(ByVal ColorVal As Long, Result As RGBTHREE) As Boolean
    
    '// separates the passed color into into red, green, and
    '// blue component values and returns the result in the
    '// referenced RGBTHREE structure
    
    Result.rgbtRed = ColorVal And 255
    Result.rgbtGreen = (ColorVal And 65535) \ 256
    Result.rgbtBlue = ColorVal \ 65536
End Function

